install 6.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. debianOS=false
  13. rhelOS=false
  14. OS=$(uname -s)
  15. if [ $OS = "Linux" ]; then
  16. OS="GNU/Linux"
  17. if [ -f /etc/os-release ]; then
  18. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  20. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  21. for i in $ID_LIKE; do
  22. #printf "$i\n"
  23. case $i in
  24. debian|ubuntu)
  25. debianOS=true
  26. break
  27. ;;
  28. rhel|fedora)
  29. rhelOS=true
  30. break
  31. ;;
  32. *)
  33. debianOS=false
  34. rhelOS=false
  35. ;;
  36. esac
  37. done
  38. elif [ -f /etc/debian-version ]; then
  39. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  40. DIST="Debian"
  41. REV=""
  42. ID_LIKE="debian"
  43. debianOS=true
  44. elif [ -f /etc/redhat-release ]; then
  45. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  46. DIST="Red-Hat"
  47. REV=""
  48. ID_LIKE="rhel"
  49. rhelOS=true
  50. else
  51. # Other Linux (No Soportado)
  52. DIST=""
  53. REV=""
  54. ID_LIKE=""
  55. fi
  56. else
  57. #UNIX, OS X, ... (No Soportado)
  58. DIST=$OS
  59. REV=""
  60. fi
  61. #printf " $DIST $REV\n"
  62. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  63. }
  64. comprobarRoot() {
  65. if [ $(id -u) -ne 0 ]; then
  66. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  67. exit 1
  68. fi
  69. }
  70. comprobarDependencias() {
  71. if [ ! -x $(which whiptail) ];then
  72. printf "ERROR:\twhiptail no disponible.\n"
  73. exit 1
  74. fi
  75. if [ $debianOS = true ];then
  76. which apt-get > /dev/null 2>&1
  77. if [ $? -ne 0 ]; then
  78. printf "ERROR:\t'apt-get' no está disponible.\n"
  79. exit 1
  80. fi
  81. #Actualizamos base de datos del repositorio
  82. printf "Actualizando repositorio APT..."
  83. result=$(apt-get -q -y update)
  84. if [ $? -ne 0 ]; then
  85. printf "\nERROR:\tImposible actualizar repositorio.\n"
  86. printf "Detalles:\n$result\n"
  87. exit 1
  88. fi
  89. printf " OK.\n"
  90. fi
  91. if [ $rhelOS = true ]; then
  92. which yum > /dev/null 2>&1
  93. if [ $? -ne 0 ]; then
  94. printf "ERROR:\t'yum' no está disponible.\n"
  95. exit 1
  96. fi
  97. printf "Actualizando repositorio YUM..."
  98. result=$(yum -y makecache 2>&1)
  99. if [ $? -ne 0 ]; then
  100. printf "\nERROR:\tImposible actualizar repositorio.\n"
  101. printf "Detalles:\n$result\n"
  102. exit 1
  103. fi
  104. printf " OK.\n"
  105. fi
  106. }
  107. mostrarBienvenida() {
  108. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  109. whiptail --title "ERROR OS NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  110. exit 1
  111. fi
  112. whiptail --title "Instalación MediaWiki" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  113. if [ $? -ne 0 ]; then
  114. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  115. exit 2
  116. fi
  117. }
  118. mostrarComponentes() {
  119. componentes=$(whiptail --title "Instalación" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 5 \
  120. "WebServer" "Instalar servidor web http/https" ON \
  121. "Database" "Instalar una base de datos SQL" ON \
  122. "PHP" "Instala PHP7" ON \
  123. "SSL/TLS" "Instala certificados para activar HTTPS" ON \
  124. "MediaWiki" "Instala la última versión de MediaWiki" ON \
  125. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  126. if [ $? -ne 0 ]; then
  127. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  128. exit 2
  129. fi
  130. # Mejora: autodetección de componentes ya instalados
  131. for i in $componentes; do
  132. case $i in
  133. \"WebServer\")
  134. printf "Instalando Servidor Web"
  135. instalarWebServer
  136. printf " OK.\n"
  137. ;;
  138. \"Database\")
  139. printf "Instalando Servidor Database..."
  140. printf " OK.\n"
  141. ;;
  142. \"PHP\")
  143. printf "Instalando PHP..."
  144. printf " OK.\n"
  145. ;;
  146. \"SSL/TLS\")
  147. printf "Instalando SSL/TLS..."
  148. printf " OK.\n"
  149. ;;
  150. \"MediaWiki\")
  151. printf "Instalando MediaWiki..."
  152. printf " OK.\n"
  153. ;;
  154. *)
  155. printf "ERROR:\tError interno (selección de componentes).\n"
  156. exit 1
  157. ;;
  158. esac
  159. done
  160. }
  161. instalarWebServer() {
  162. webServer=$(whiptail --title "Servidor Web" --radiolist "" 20 70 2 \
  163. "Apache" "Instalar el servidor web Apache2" ON \
  164. "Nginx" "Instalar el servidor web Nginx" OFF \
  165. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  166. # Preguntar otras opciones de configuración
  167. case $webServer in
  168. Apache)
  169. printf " Apache..."
  170. instalarApache
  171. ;;
  172. Nginx)
  173. printf " Nginx..."
  174. instalarNginx
  175. ;;
  176. *)
  177. printf "\nERROR:\tError interno (selección de web server).\n"
  178. exit 1
  179. ;;
  180. esac
  181. }
  182. instalarApache() {
  183. if [ $debianOS = true ];then
  184. result=$(apt-get -q -y install apache2 2>&1)
  185. if [ $? -ne 0 ]; then
  186. printf "\nERROR:\tError al instalar apache2.\n"
  187. printf "Detalles:\n$result\n"
  188. exit 1
  189. fi
  190. elif [ $rhelOS = true ]; then
  191. result=$(yum -y install httpd 2>&1)
  192. if [ $? -ne 0 ]; then
  193. printf "\nERROR:\tError al instalar apache2.\n"
  194. printf "Detalles:\n$result\n"
  195. exit 1
  196. fi
  197. else
  198. printf "\nERROR:\tError interno (instalación apache).\n"
  199. exit 1
  200. fi
  201. }
  202. instalarNginx() {
  203. if [ $debianOS = true ];then
  204. result=$(apt-get -q -y install nginx 2>&1)
  205. if [ $? -ne 0 ]; then
  206. printf "\nERROR:\tError al instalar apache2.\n"
  207. printf "Detalles:\n$result\n"
  208. exit 1
  209. fi
  210. elif [ $rhelOS = true ]; then
  211. # Hay que instalar primero otro repositorio
  212. result=$(yum -y install nginx 2>&1)
  213. if [ $? -ne 0 ]; then
  214. printf "\nERROR:\tError al instalar apache2.\n"
  215. printf "Detalles:\n$result\n"
  216. exit 1
  217. fi
  218. else
  219. printf "\nERROR:\tError interno (instalación apache).\n"
  220. exit 1
  221. fi
  222. }
  223. # Comprobamos
  224. comprobarRoot
  225. OSInfo
  226. comprobarDependencias
  227. # Bienvenida
  228. mostrarBienvenida
  229. # Mejora: instalación express vs instalación avanzada
  230. # Selección de componentes
  231. mostrarComponentes
  232. # Autodestrucción
  233. {
  234. for i in $(seq 0 5 50); do
  235. sleep 0.1
  236. echo $i
  237. done
  238. } | whiptail --gauge "Autodestrucción..." 7 70 0
  239. {
  240. for i in $(seq 50 5 100); do
  241. sleep 0.1
  242. echo $i
  243. done
  244. } | whiptail --gauge "Autopulverización..." 7 70 50